<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2010 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class random_album_highlight_theme_Core {
  static function thumb_top($theme, $child) {
    // only show the random album code if the album does not have a recored
    $record = ORM::factory("random_album_highlight")->where("item_id", "=", $child->id)->count_all();
	if ((!$record) &&  ($child->is_album())){
	  // sometimes $rnd might be empty so try a few times
      $attempts = 0;
      do {
	    if (module::get_var("random_album_highlight", "subalbums") == true) {
		  $rnd = ORM::factory("item")->viewable()
		      ->where("rand_key", "<", ((float)mt_rand()) / (float)mt_getrandmax())
			  ->where("type", "=", "photo")
			  ->where("left_ptr", ">=", $child->left_ptr)
			  ->where("right_ptr", "<=", $child->right_ptr)
			  ->order_by("rand_key", "DESC")
			  ->find();
		} else {
		  $rnd = item::random_query()->where("parent_id", "=", $child->id)->find();
		}
	  } while (!$rnd && $attempts++ < 5);
	  // we tried 5 times give up if $rnd is not loaded.
	  if ($rnd->loaded()) {
	    $view = new View("code_thumb_top.html");
	    $view->child = $child;
	    $view->rnd = $rnd;
	    print $view;
	  }
	}
  }
}
